#!/usr/bin/env bash                                                            

TRUNK=$(dirname ${0})/..
GATHER=${TRUNK}/ext/lchd/bin/mfgath.py
if [ -z "$PYTHON" ]; then
  PYTHON=python
fi

function gather_local_bin_files {
  ((c=1))
  FLIST=$(ls *_3D_d*_p0000.bin 2>/dev/null)
  if [ -n "${FLIST}" ]; then
    for FBIN in ${FLIST}; do
        PREFIX=${FBIN%_p0000.bin}
        FHDF5=${PREFIX}".h5"
        if [ -f "$FHDF5" ]; then 
          echo "Processing $FHDF5"
          (${PYTHON} $GATHER $FHDF5 && mv $FBIN ${PREFIX}_master_sec_copy.h5 raw/) &
          ((j=c%10))
          ((c++))
        else
          echo "Strangely, file $FBIN was found and not $FHDF5."
          wait 
          exit -1
        fi
        if ((j==0)); then
            wait
        fi
    done
  fi
  wait
}

BINFILES=""
for DIR in Phi3D moment3D; do
   FLIST=$(ls ${DIR}/*_3D_d*_p0000.bin 2>/dev/null) 
   if [ -d ${DIR} ]; then
     (cd $DIR; mkdir raw 2>/dev/null; gather_local_bin_files)
   else
     echo "Error: Directory $DIR not found"
     exit -1
   fi
   BINFILES="$BINFILES$FLIST"
done

if [ -d sp2 ]; then
  for DIR in Phi3D moment3D; do
     FLIST=$(ls ${DIR}/*_3D_d*_p0000.bin 2>/dev/null) 
     if [ -d ${DIR} ]; then
       (cd $DIR; mkdir raw 2>/dev/null; gather_local_bin_files)
     else
       echo "Error: Directory sp2/$DIR not found"
       exit -1
     fi
     BINFILES="$BINFILES$FLIST"
  done
fi
if [ -z "${BINFILES}" ]; then
  SCRIPT=`basename $0`
  printf "\nNothing has been done: $SCRIPT has found no binary files to postprocess.\n\n"  
fi