!*********************************************************************
!  Copyright Euratom-CEA
!  Authors : 
!     Virginie Grandgirard (virginie.grandgirard@cea.fr)
!     Chantal Passeron (chantal.passeron@cea.fr)
!     Guillaume Latu (guillaume.latu@cea.fr)
!     Xavier Garbet (xavier.garbet@cea.fr)
!     Philippe Ghendrih (philippe.ghendrih@cea.fr)
!     Yanick Sarazin (yanick.sarazin@cea.fr)
!  
!  This code GYSELA (for GYrokinetic SEmi-LAgrangian) 
!  is a 5D gyrokinetic global full-f code for simulating 
!  the plasma turbulence in a tokamak.
!  
!  This software is governed by the CeCILL-B license 
!  under French law and abiding by the rules of distribution 
!  of free software.  You can  use, modify and redistribute 
!  the software under the terms of the CeCILL-B license as 
!  circulated by CEA, CNRS and INRIA at the following URL
!  "http://www.cecill.info". 
!*********************************************************************

!---------------------------------------------------------------------
!> \file
!> This is a file that defines all macros that might be used
!> everywhere in GYSELA Fortran code, especially those that depend on
!> configuration options specified in the Makefile.
!> These configuration options can either be provided through a
!> genearated config.h or directly on the command line.
!---------------------------------------------------------------------

#ifndef CONFIG_F_INC__
#define CONFIG_F_INC__

#ifdef HAVE_CONFIG_H
#include "config-cmake.h"
#endif
#include "config-default.h"

#include "parallelization/deterministic.inc"
#include "system_tools/wrap_alloc.inc"

#endif
