
#if 0
// *******************************************************************
//  Copyright Euratom-CEA
//  Authors : 
//     Virginie Grandgirard (virginie.grandgirard@cea.fr)
//     Chantal Passeron (chantal.passeron@cea.fr)
//     Guillaume Latu (guillaume.latu@cea.fr)
//     Xavier Garbet (xavier.garbet@cea.fr)
//     Philippe Ghendrih (philippe.ghendrih@cea.fr)
//     Yanick Sarazin (yanick.sarazin@cea.fr)
//  
//  This code GYSELA (for GYrokinetic SEmi-LAgrangian) 
//  is a 5D gyrokinetic global full-f code for simulating 
//  the plasma turbulence in a tokamak.
//  
//  This software is governed by the CeCILL-B license 
//  under French law and abiding by the rules of distribution 
//  of free software.  You can  use, modify and redistribute 
//  the software under the terms of the CeCILL-B license as 
//  circulated by CEA, CNRS and INRIA at the following URL
//  "http://www.cecill.info".
// *******************************************************************
#endif

#ifndef CONFIG_DEFAULT_H__
#define CONFIG_DEFAULT_H__

#if 0
/** \file
 * This is the configuration file where "profile macros" and default
 * values for macros are defined.
 * 
 *  A profile macro is a macro that is not used directly in the code
 *  but that induces specific values for other macros and is thus
 *  a shorthand to specify on the command line
 */
//  In order to be able to use this file from both Fortran and C, it
//  should contain pre-processor code only and comments should be
//  enclosed in #if 0 ... #endif
#endif



#if 0
//--------------------------------------------------------------------
// These are the "profile macros"
// Please note that specifically defined value should take precedence
// to values defined here so that each definition should be enclosed
// in a #ifndef
#endif

#if 0
//DEBUG is a profile macro enabling debug build
#endif
#ifdef DEBUG
#ifndef VERBOSITY
#define VERBOSITY 1
#endif
#endif

#if 0
//IBM is a profile macro enabled when using an IBM compiler
#endif
#ifdef IBM
#ifndef FLUSH_SYMBOL
#define FLUSH_SYMBOL flush_
#endif
#ifndef FORTSYM
#define FORTSYM(lower, upper) lower
#endif
#endif

#if 0
//HOPPER is a profile macro enabled on the HOPPER machine
#endif
#ifdef HOPPER
#define ATANH_NOT_IMPLICIT
#endif



#if 0
//---------------------------------------------------------------------
// This defines the default value of macro that require a value
#endif

#ifndef VERBOSITY
#define VERBOSITY 0
#endif

#ifndef DFLT_HDF5_COMPRESSION
#define DFLT_HDF5_COMPRESSION 1
#endif

#ifndef DFLT_F4D_TRANSPOSE
#define DFLT_F4D_TRANSPOSE TRANSPOSE_SENDIRECV
#endif

#ifndef FLUSH_SYMBOL
#define FLUSH_SYMBOL flush
#endif

#ifndef FORTSYM
#define FORTSYM(lower, upper) lower##_
#endif

#ifdef  __GFORTRAN__
#define MKSTR(symbol) 'symbol'
#else
#define MKSTR(symbol) #symbol
#endif

#if 0
/* The QUICK_COMPIL functionality allows one to 
   compile faster than commonly. Only parts of
   Gysela will be compiled. In order to use
   it, define the MACRO QUICK_COMPIL at
   compilation time. For example with the old  
   Makefile (i.e. not with cmake) you can launch:
     CE_DFLAGS=-DQUICK_COMPIL make -j
   on Bluegene, the syntax is different:
     CE_DFLAGS=-WF,-DQUICK_COMPIL make -j 
*/
#endif
#ifdef QUICK_COMPIL

#define HAS_QN_V5                                                            
#define HAS_DIFF
#define HAS_SRC
#define HAS_ADV_TRANSP
#define HAS_COLL_V2

#else

#if 0
// Keep source features
#endif
#define HAS_SRC            
#if 0
// Keep species transfer features
#endif
#define HAS_SP_TRANSF
#if 0
// Define QN solvers that will be compiled
#endif
#define HAS_QN_V5
#define HAS_QN_V4
#define HAS_QN_V3
#define HAS_QN_V2
#define HAS_QN_V1
#if 0
// Keep QN filter
#endif
#define HAS_QN_FILTER
#if 0
// Keep Krook feature
#endif
#define HAS_KROOK
#if 0
// Keep Diffusion in buffer regions
#endif
#define HAS_DIFF
#if 0
// Define Collision operator version that will be compiled 
#endif
#define HAS_COLL_V2
#define HAS_COLL_V1
#if 0
// Define Advection operator version that will be compiled 
#endif
#define HAS_ADV_TRANSP
#define HAS_ADV_PSM
#define HAS_ADV_PRECOMP
#define HAS_ADV_PPM
#define HAS_ADV_OLD    
#define HAS_ADV_LOCAL

#endif

#if 0
// If PSM or PPM advection solver is used then
// some common code has to be actived through
// the HAS_CONSERV macro definition
#endif
#if defined(HAS_PSM) || defined(HAS_PPM)
#define HAS_CONSERV
#endif

#endif
