!*********************************************************************
!  Copyright Euratom-CEA
!  Authors : 
!     Virginie Grandgirard (virginie.grandgirard@cea.fr)
!     Chantal Passeron (chantal.passeron@cea.fr)
!     Guillaume Latu (guillaume.latu@cea.fr)
!     Xavier Garbet (xavier.garbet@cea.fr)
!     Philippe Ghendrih (philippe.ghendrih@cea.fr)
!     Yanick Sarazin (yanick.sarazin@cea.fr)
!  
!  This code GYSELA (for GYrokinetic SEmi-LAgrangian) 
!  is a 5D gyrokinetic global full-f code for simulating 
!  the plasma turbulence in a tokamak.
!  
!  This software is governed by the CeCILL-B license 
!  under French law and abiding by the rules of distribution 
!  of free software.  You can  use, modify and redistribute 
!  the software under the terms of the CeCILL-B license as 
!  circulated by CEA, CNRS and INRIA at the following URL
!  "http://www.cecill.info". 
!*********************************************************************

#ifndef PARALLELIZATION_DETERMINISTIC_INC__
#define PARALLELIZATION_DETERMINISTIC_INC__

#include "config-F.inc"

#ifndef DETERMINISTIC_MPI
#define MY_Reduce MPI_Reduce
#define MY_Allreduce MPI_Allreduce
#else
#define MY_Reduce DET_Reduce
#define MY_Allreduce DET_Allreduce
#endif

#endif
