!*********************************************************************
!  Copyright Euratom-CEA
!  Authors : 
!     Fabien Rozar (fabien.rozar@cea.fr)
!  
!  This code GYSELA (for GYrokinetic SEmi-LAgrangian) 
!  is a 5D gyrokinetic global full-f code for simulating 
!  the plasma turbulence in a tokamak.
!  
!  This software is governed by the CeCILL-B license 
!  under French law and abiding by the rules of distribution 
!  of free software.  You can  use, modify and redistribute 
!  the software under the terms of the CeCILL-B license as 
!  circulated by CEA, CNRS and INRIA at the following URL
!  "http://www.cecill.info". 
!*********************************************************************

!---------------------------------------------------------------------
!> \file
!> This is a file that defines macros about allocations.
!---------------------------------------------------------------------

#ifndef SYSTEM_TOOLS_WRAP_ALLOC_INC__
#define SYSTEM_TOOLS_WRAP_ALLOC_INC__

! ****** LOC_TAKE ******
! ** ALLOCATION WITHOUT INITIALISATION
#define FTR_ALLOC_5(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,dim9,dim10) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,dim9,dim10,\
MKSTR(array),__FILE__,__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),\
MKSTR(dim5),MKSTR(dim6),MKSTR(dim7),MKSTR(dim8),MKSTR(dim9),MKSTR(dim10),\
pfillzero=.false.)

#define FTR_ALLOC_4(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,MKSTR(array),\
__FILE__,__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),MKSTR(dim5),\
MKSTR(dim6),MKSTR(dim7),MKSTR(dim8),pfillzero=.false.)

#define FTR_ALLOC_3(array,dim1,dim2,dim3,dim4,dim5,dim6) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,MKSTR(array),__FILE__,\
__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),MKSTR(dim5),MKSTR(dim6),\
pfillzero=.false.)

#define FTR_ALLOC_2(array,dim1,dim2,dim3,dim4) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,MKSTR(array),__FILE__,__LINE__,\
MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),pfillzero=.false.)

#define FTR_ALLOC_1(array,dim1,dim2) \
	ftr_alloc(array,dim1,dim2,MKSTR(array),__FILE__,__LINE__,\
MKSTR(dim1),MKSTR(dim2),pfillzero=.false.)

! ** ALLOCATION WITH INITIALISATION TO ZERO
#define FTR_ALLOC_5_ZERO(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,dim9,dim10) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,dim9,dim10,\
MKSTR(array),__FILE__,__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),\
MKSTR(dim5),MKSTR(dim6),MKSTR(dim7),MKSTR(dim8),MKSTR(dim9),MKSTR(dim10),\
pfillzero=.true.)

#define FTR_ALLOC_4_ZERO(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,dim7,dim8,MKSTR(array),\
__FILE__,__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),MKSTR(dim5),\
MKSTR(dim6),MKSTR(dim7),MKSTR(dim8),pfillzero=.true.)

#define FTR_ALLOC_3_ZERO(array,dim1,dim2,dim3,dim4,dim5,dim6) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,dim5,dim6,MKSTR(array),__FILE__,\
__LINE__,MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),MKSTR(dim5),MKSTR(dim6),\
pfillzero=.true.)

#define FTR_ALLOC_2_ZERO(array,dim1,dim2,dim3,dim4) \
	ftr_alloc(array,dim1,dim2,dim3,dim4,MKSTR(array),__FILE__,__LINE__,\
MKSTR(dim1),MKSTR(dim2),MKSTR(dim3),MKSTR(dim4),pfillzero=.true.)

#define FTR_ALLOC_1_ZERO(array,dim1,dim2) \
	ftr_alloc(array,dim1,dim2,MKSTR(array),__FILE__,__LINE__,\
MKSTR(dim1),MKSTR(dim2),pfillzero=.true.)

! ****** TIPS ******
#define FTR_DEALLOC(array) \
	ftr_dealloc(array,MKSTR(array),__FILE__,__LINE__)

#endif
